(function($) {
    $.fn.socialCounter = function(options) {
        var settings = $.extend({
            users: {
                twitter_user: '',
                facebook_user: '',
                facebook_token: '',
                instagram_user: '',
                instagram_token: '',
                google_plus_id: '',
                google_plus_key: '',
                youtube_user: '',
                youtube_key: '',
                pinterest_user: '',
                dribbble_user: '',
                github_user: ''
            },
            api: {
                dribbble_token: '',
                soundcloud_user_id: '',
                soundcloud_client_id: '',
                vimeo_user: '',
                vimeo_token: '',
                github_user: '',
                behance_user: '',
                behance_client_id: '',
                vk_id: '',
                foursquare_user: '',
                foursquare_token: ''
            }
        }, options);
        $('.social-counter .item').each(function() {
            var icon = $(this).data('icon');
            var text = $(this).data('text');
            if (icon && icon != '') {
                $(this).append('<i class="' + icon + '"></i>');
                $(this).append('<span class="count"></span>');
            } else {
                $(this).append('<span class="count"></span>');
            }
            if (text && text != '') {
                $(this).append('<em>' + text + '</em>');
            }
        });

        function pinterest() {
            $.ajax({
                url: 'https://api.pinterest.com/v3/pidgets/users/' + settings.users.pinterest_user + '/pins',
                dataType: 'jsonp',
                type: 'GET',
                success: function(data) {
                    var followers = parseInt(data.data.user.follower_count);
                    var k = kFormatter(followers);
                    $('.social-counter .item.pinterest .count').append(k);
                    $('.social-counter .item.pinterest').attr('href', 'https://pinterest.com/' + settings.users.pinterest_user);
                    getTotal(followers);
                }
            });
        }

        function dribbble() {
            $.ajax({
                url: 'https://api.dribbble.com/v1/users/' + settings.users.dribbble_user,
                dataType: 'json',
                type: 'GET',
                data: {
                    access_token: settings.api.dribbble_token
                },
                success: function(data) {
                    var followers = parseInt(data.followers_count);
                    var k = kFormatter(followers);
                    $('.social-counter .item.dribbble .count').append(k);
                    $('.social-counter .item.dribbble').attr('href', 'https://dribbble.com/' + settings.users.dribbble_user);
                    getTotal(followers);
                }
            });
        }

        function facebook() {
            $.ajax({
                url: 'https://graph.facebook.com/v3.1/' + settings.users.facebook_user,
                dataType: 'json',
                type: 'GET',
                data: {
                    access_token: settings.api.facebook_token,
                    fields: 'fan_count'
                },
                success: function(data) {
                    var followers = parseInt(data.fan_count);
                    var k = kFormatter(followers);
                    $('.social-counter .item.facebook .count').append(k);
                    $('.social-counter .item.facebook').attr('href', 'https://facebook.com/' + settings.users.facebook_user);
                    getTotal(followers);
                }
            });
        }

        function instagram() {
            $.ajax({
                url: 'https://api.instagram.com/v1/users/self/',
                dataType: 'jsonp',
                type: 'GET',
                data: {
                    access_token: settings.api.instagram_token
                },
                success: function(data) {
                    var followers = parseInt(data.data.counts.followed_by);
                    var k = kFormatter(followers);
                    $('.social-counter .item.instagram .count').append(k);
                    $('.social-counter .item.instagram').attr('href', 'https://instagram.com/' + settings.users.instagram_user);
                    getTotal(followers);
                }
            });
        }

        function google() {
            $.ajax({
                url: 'https://www.googleapis.com/plus/v1/people/' + settings.users.google_plus_id,
                type: "GET",
                dataType: "json",
                data: {
                    key: settings.api.google_plus_key
                },
                success: function(data) {
                    var followers = parseInt(data.circledByCount);
                    var k = kFormatter(followers);
                    $(".social-counter .item.google .count").append(k);
                    $('.social-counter .item.google').attr('href', 'https://plus.google.com/' + settings.users.google_plus_id);
                    getTotal(followers);
                }
            });
        }

        function youtube() {
            $.ajax({
                url: 'https://www.googleapis.com/youtube/v3/channels',
                dataType: 'jsonp',
                type: 'GET',
                data: {
                    part: 'statistics',
                    forUsername: settings.users.youtube_user,
                    key: settings.api.youtube_key
                },
                success: function(data) {
                    var subscribers = parseInt(data.items[0].statistics.subscriberCount);
                    var k = kFormatter(subscribers);
                    $('.social-counter .item.youtube .count').append(k);
                    $('.social-counter .item.youtube').attr('href', 'https://youtube.com/' + settings.users.youtube_user);
                    getTotal(subscribers);
                }
            });
        }

        function soundcloud() {
            $.ajax({
                url: 'http://api.soundcloud.com/users/' + settings.users.soundcloud_user_id,
                dataType: 'json',
                type: 'GET',
                data: {
                    client_id: settings.api.soundcloud_client_id
                },
                success: function(data) {
                    var followers = parseInt(data.followers_count);
                    var k = kFormatter(followers);
                    $('.social-counter .item.soundcloud .count').append(k);
                    $('.social-counter .item.soundcloud').attr('href', data.permalink_url);
                    getTotal(followers);
                }
            });
        }

        function vimeo() {
            $.ajax({
                url: 'https://api.vimeo.com/users/' + settings.users.vimeo_user + '/followers',
                dataType: 'json',
                type: 'GET',
                data: {
                    access_token: settings.api.vimeo_token
                },
                success: function(data) {
                    var followers = parseInt(data.total);
                    $('.social-counter .item.vimeo .count').append(followers).digits();
                    $('.social-counter .item.vimeo').attr('href', 'https://vimeo.com/' + settings.users.vimeo_user);
                    getTotal(followers);
                }
            });
        }

        function twitter() {
            $.ajax({
                url: 'http://juanvargas.net/SocialCounters/twitter/index.php',
                dataType: 'json',
                type: 'GET',
                data: {
                    user: settings.users.twitter_user
                },
                success: function(data) {
                    var followers = parseInt(data.followers);
                    $('.social-counter .item.twitter .count').append(followers).digits();
                    $('.social-counter .item.twitter').attr('href', 'https://twitter.com/' + settings.users.twitter_user);
                    getTotal(followers);
                }
            });
        }

        function github() {
            $.ajax({
                url: 'https://api.github.com/users/' + settings.users.github_user,
                dataType: 'json',
                type: 'GET',
                success: function(data) {
                    var followers = parseInt(data.followers);
                    var k = kFormatter(followers);
                    $('.social-counter .item.github .count').append(k);
                    $('.social-counter .item.github').attr('href', 'https://github.com/' + settings.users.github_user);
                    getTotal(followers);
                }
            });
        }

        function behance() {
            $.ajax({
                url: 'https://api.behance.net/v2/users/' + settings.users.behance_user,
                dataType: 'jsonp',
                type: 'GET',
                data: {
                    client_id: settings.api.behance_client_id
                },
                success: function(data) {
                    var followers = parseInt(data.user.stats.followers);
                    var k = kFormatter(followers);
                    $('.social-counter .item.behance .count').append(k);
                    $('.social-counter .item.behance').attr('href', 'https://behance.net/' + settings.users.behance_user);
                    getTotal(followers);
                }
            });
        }

        function vk() {
            $.ajax({
                url: 'https://api.vk.com/method/users.getFollowers',
                dataType: 'jsonp',
                type: 'GET',
                data: {
                    user_id: settings.users.vk_id,
                    access_token: settings.api.vk_access_token,
                    v: 5.84
                },
                success: function(data) {
                    var followers = (data.response) ? parseInt(data.response.count) : 0;
                    var k = kFormatter(followers);
                    $('.social-counter .item.vk .count').append(k);
                    $('.social-counter .item.vk').attr('href', 'https://vk.com/id' + settings.users.vk_id);
                    getTotal(followers);
                }
            });
        }
        $.fn.digits = function() {
            return this.each(function() {
                $(this).text($(this).text().replace(/(\d)(?=(\d\d\d)+(?!\d))/g, "$1,"));
            })
        }

        function kFormatter(num) {
            return num > 999 ? (num / 1000).toFixed(1) + 'k' : num;
        }
        var total = 0;

        function getTotal(data) {
            total = total + data;
            $("#total").html(total).digits();
            $("#total_k").html(kFormatter(total));
        }
        if (settings.users.twitter_user != '') {
            twitter();
        }
        if (settings.users.facebook_user != '' && settings.facebook_token != '') {
            facebook();
        }
        if (settings.users.instagram_user != '' && settings.instagram_token != '') {
            instagram();
        }
        if (settings.users.google_plus_id != '' && settings.google_plus_key != '') {
            google();
        }
        if (settings.users.youtube_user != '' && settings.youtube_key != '') {
            youtube();
        }
        if (settings.pinterest_user != '') {
            pinterest();
        }
        if (settings.dribbble_user != '' && settings.dribbble_token != '') {
            dribbble();
        }
        if (settings.soundcloud_user_id != '' && settings.soundcloud_client_id != '') {
            soundcloud();
        }
        if (settings.vimeo_user != '' && settings.vimeo_token != '') {
            vimeo();
        }
        if (settings.github_user != '') {
            github();
        }
        if (settings.behance_user != '' && settings.behance_client_id != '') {
            behance();
        }
        if (settings.vk_id != '') {
            vk();
        }
    };
}(jQuery));